#include <gst/gst.h>
#include <glib.h>
#include <string.h>
#include <iostream>

#include <stdio.h>
#include <termios.h>
#include <unistd.h>

using namespace std;

struct ThreadArgs{
	//int argc;
  //char **argv[];
	char* filename;
};


int mygetch( ) {
  struct termios oldt,
                 newt;
  int            ch;
  tcgetattr( STDIN_FILENO, &oldt );
  newt = oldt;
  newt.c_lflag &= ~( ICANON | ECHO );
  tcsetattr( STDIN_FILENO, TCSANOW, &newt );
  ch = getchar();
  tcsetattr( STDIN_FILENO, TCSANOW, &oldt );
  return ch;
}


 
static gboolean
bus_call (GstBus     *bus,
          GstMessage *msg,
          gpointer    data)
{
  GMainLoop *loop = (GMainLoop *) data;
 
  switch (GST_MESSAGE_TYPE (msg)) {
 
    case GST_MESSAGE_EOS:
      g_print ("End of stream\n");
      g_main_loop_quit (loop);
      break;
 
    case GST_MESSAGE_ERROR: {
      gchar  *debug;
      GError *error;
 
      gst_message_parse_error (msg, &error, &debug);
      g_free (debug);
 
      g_printerr ("Error: %s\n", error->message);
      g_error_free (error);
 
      g_main_loop_quit (loop);
      break;
    }
    default:
      break;
  }
 
  return TRUE;
}

//void* (*)(void*)

//int (*)(int, char**, char*)
//int PlaySound( int argc, char *argv[], char *filepath ){

void* PlaySound( void* ptr ){

	char* temp = (char*)ptr;
	int size = strlen(temp)+1;
	char* filepath = new char[size];
	for( int i =0; i<size; ++i )
		filepath[i] = temp[i];

//	cout<<"inthread:"<<*str<<endl;
	

//	char* filepath = temp;//(char *) ptr;
  GMainLoop *loop;

//	cout<<"filepath2:"<<filepath<<endl;
 
  GstElement *pipeline, *bin;
  GstBus *bus;
 
	gchar path[100];
 
  /* Initialisation */
  gst_init (NULL, NULL);
 
  loop = g_main_loop_new (NULL, FALSE);
 
  /* Create gstreamer elements */
  pipeline = gst_pipeline_new ("audio-player");
  bin   = gst_element_factory_make ("playbin", "file-source");
 
  if (!pipeline || !bin) {
    g_printerr ("One element could not be created. Exiting.\n");
    return NULL;
  }
 
  /* Set up the pipeline */
 
  /* we set the input filename to the source element */
	/* string functions can be removed. then the parameter has to contain
        file:/// in the beginning to play a file */
  strcpy(path, "file:///");
  strcat(path, filepath);

  g_object_set (G_OBJECT (bin), "uri", path, NULL);
 
  /* we add a message handler */
  bus = gst_pipeline_get_bus (GST_PIPELINE (pipeline));
  gst_bus_add_watch (bus, bus_call, loop);
  gst_object_unref (bus);
 
  /* we add all elements into the pipeline */
  gst_bin_add_many (GST_BIN (pipeline),
                    bin, NULL);
 
  /* Set the pipeline to "playing" state*/
  g_print ("Now playing: %s\n", filepath);
  gst_element_set_state (pipeline, GST_STATE_PLAYING);
 
  /* Iterate */
  g_print ("Running...\n");
  g_main_loop_run (loop);
 
  /* Out of the main loop, clean up nicely */
  g_print ("Returned, stopping playback\n");
  gst_element_set_state (pipeline, GST_STATE_NULL);
 
  g_print ("Deleting pipeline\n");
  gst_object_unref (GST_OBJECT (pipeline));

	delete filepath;
	pthread_exit(NULL);
 
}

void getNoteFile( char input, int insInt, string& filepath  );


int main ( int argc, char *argv[] ){

	cout<< "Hello"<< endl;
	cout<< "Choose instrument :"<< endl;
	cout<< "1 - STRINGS"<< endl;
	cout<< "2 - ACOUSTIC GUITAR"<< endl;
	cout<< "3 - DRUM KIT"<< endl;
	cout<< "4 - FLUTE"<< endl;
	cout<< "5 - XYLOPHONE"<< endl;
	cout<< "6 - HIPHOP KIT"<< endl;
	cout<< "7 - OUD"<< endl;
	cout<< "8 - MARIMBA"<< endl;
	cout<< "p - exit"<< endl;
	cout<< ""<< endl;

  int insInt = 1;

  char input = ' ';	
  
	while( input != 'p' ){

		input = mygetch();
		
		if( input == '1' ){
				insInt = 1;
				continue;
		}
		else if( input == '2' ){
			insInt = 2;
			continue;
		}
		else if( input == '3' ){
			insInt = 3;
			continue;
		}
		else if( input == '4' ){
			insInt = 4;
			continue;
		}
		else if( input == '5' ){
			insInt = 5;
			continue;
		}
		else if( input == '6' ){
			insInt = 6;
			continue;
		}
		else if( input == '7' ){
			insInt = 7;
			continue;
		}
		else if( input == '8' ){
			insInt = 8;
			continue;
		}
		else if( input == 'p' ){
			continue;
		}

		string filepath;
    getNoteFile( input, insInt, filepath );		

		char* temp = new char[filepath.length()+1];
		unsigned int i;
		for( i =0; i < filepath.length(); ++i )
			temp[i] = filepath[i];
		temp[i] = '\0';

		int NUM_THREADS = 1;
		pthread_t threads[NUM_THREADS];
		int rc;
//		cout<<"filepath:"<<temp<<endl;
		rc = pthread_create(&threads[0], NULL, PlaySound, (void *)temp);
		if (rc){
			 printf("ERROR; return code from pthread_create() is %d\n", rc);
			 exit(-1);
		}

//		PlaySound( argc, argv, temp );

		
	}
	return 1;
}

void getNoteFile( char input, int insInt, string &filepath ){

//	string path = "/home/codecamp/INSTRUMENTS_V3/";
	string path = "/root/";
	string instrument;
	string notefile;

	if( insInt == 1 ){
		instrument = "UMSIC_STRINGS2/";
		switch ( input )
		{
		   case 'a':
		      notefile = "strings_a3_g-3_a3.wav";
		      break;
		   case 's':
		      notefile = "strings_a-2_g-2_b2.wav";
		      break;
		   case 'd':
		      notefile = "strings_c4_a-3_c4.wav";
		      break;
		   case 'f':
		      notefile = "strings_e4_c-4_e4.wav";
		      break;
		   case 'g':
		      notefile = "strings_f3_c3_f3.wav";
		      break;
		   case 'h':
		      notefile = "strings_g2_c1_g2.wav";
		      break;
		   case 'j':
		      notefile = "strings_g3_f-3_g3.wav";
		      break;
		   default:
		      notefile = "strings_g4_f4_c6.wav";
		      break;
		}
	}
	else if( insInt == 2 ){
		instrument = "UMSIC_ACOUSTIC_GUITAR/";
		switch ( input )
		{
		   case 'a':
		      notefile = "ac_guitar_a2_g-2_a-2.wav";
		      break;
		   case 's':
		      notefile = "ac_guitar_a4_g-4_a-4.wav";
		      break;
		   case 'd':
		      notefile = "ac_guitar_b1_a-1_c2.wav";
		      break;
		   case 'f':
		      notefile = "ac_guitar_b3_a-3_c4.wav";
		      break;
		   case 'g':
		      notefile = "ac_guitar_c1_c1_d1.wav";
		      break;
		   case 'h':
		      notefile = "ac_guitar_c3_b2_d3.wav";
		      break;
		   case 'j':
		      notefile = "ac_guitar_c5_b4_c5.wav";
		      break;
		   default:
		      notefile = "ac_guitar_d4_c-4_d-4.wav";
		      break;
		}
	}

	else if( insInt == 3 ){
		instrument = "UMSIC_DRUM_KIT/";
		switch ( input )
		{
		   case 'a':
		      notefile = "drumkit_a1_tom2.wav";
		      break;
		   case 's':
		      notefile = "drumkit_a-1_crash2.wav";
		      break;
		   case 'd':
		      notefile = "drumkit_b1_tom3.wav";
		      break;
		   case 'f':
		      notefile = "drumkit_c1_kick.wav";
		      break;
		   case 'g':
		      notefile = "drumkit_d1_snare.wav";
		      break;
		   case 'h':
		      notefile = "drumkit_e1_hhcls.wav";
		      break;
		   case 'j':
		      notefile = "drumkit_f1_hhopn.wav";
		      break;
		   default:
		      notefile = "drumkit_f-1_ride1.wav";
		      break;
		}
	}

	else if( insInt == 4 ){
		instrument = "UMSIC_FLUTE/";
		switch ( input )
		{
		   case 'a':
		      notefile = "flute_a3_c3_a-3.wav";
		      break;
		   case 's':
		      notefile = "flute_a4_g-4_a-4.wav";
		      break;
		   case 'd':
		      notefile = "flute_c4_b3_c-4.wav";
		      break;
		   case 'f':
		      notefile = "flute_c5_b4_c6.wav";
		      break;
		   case 'g':
		      notefile = "flute_d-4_d4_e4.wav";
		      break;
/*		   case 'h':
		      notefile = "strings_g2_c1_g2.wav";
		      break;
		   case 'j':
		      notefile = "strings_g3_f-3_g3.wav";
		      break;
	*/	   default:
		      notefile = "flute_f-4_f4_g4.wav";
		      break;
		}
	}

else if( insInt == 5 ){
		instrument = "UMSIC_XYLOPHONE/";
		switch ( input )
		{
		   case 'a':
		      notefile = "xylophone_c3_a2_d3.wav";
		      break;
		   case 's':
		      notefile = "xylophone_c4_a-3_d4.wav";
		      break;
		   case 'd':
		      notefile = "xylophone_c5_a4_d-5.wav";
		      break;
		   case 'f':
		      notefile = "xylophone_f2_c2_g-2.wav";
		      break;
		   case 'g':
		      notefile = "xylophone_f3_d-3_a3.wav";
		      break;
		   case 'h':
		      notefile = "xylophone_f4_d-4_g-4.wav";
		      break;
/*		   case 'j':
		      notefile = "strings_g3_f-3_g3.wav";
		      break;
	*/	   default:
		      notefile = "xylophone_f5_e5_c6.wav";
		      break;
		}
	}

else if( insInt == 6 ){
		instrument = "UMSIC_HIPHOP_KIT/";
		switch ( input )
		{
		   case 'a':
		      notefile = "hiphopkit_a-1_revcrash.wav";
		      break;
		   case 's':
		      notefile = "hiphopkit_c1_kick1.wav";
		      break;
		   case 'd':
		      notefile = "hiphopkit_c-1_kick2.wav";
		      break;
		   case 'f':
		      notefile = "hiphopkit_d1_snare1.wav";
		      break;
		   case 'g':
		      notefile = "hiphopkit_d-1_snare2.wav";
		      break;
  	   case 'h':
		      notefile = "hiphopkit_e1_hhcls.wav";
		      break;
		   case 'j':
		      notefile = "hiphopkit_f1_hhopn.wav";
		      break;
	     default:
		      notefile = "hiphopkit_f-1_clap.wav";
		      break;
		}
	}

else if( insInt == 7 ){
		instrument = "UMSIC_UD/";
		switch ( input )
		{
		   case 'a':
		      notefile = "ud_b2_a2_c3.wav";
		      break;
		   case 's':
		      notefile = "ud_b3_a3_c4.wav";
		      break;
		   case 'd':
		      notefile = "ud_b4_a4_c5.wav";
		      break;
		   case 'f':
		      notefile = "ud_c-3_c-3_d-3.wav";
		      break;
		   case 'g':
		      notefile = "ud_d4_c-4_e4.wav";
		      break;
		   case 'h':
		      notefile = "ud_e2_c1_f2.wav";
		      break;
		   case 'j':
		      notefile = "ud_e3_e3_f-3.wav";
		      break;
		   default:
		      notefile = "ud_f4_f4_a4.wav";
		      break;
		}
	}

else if( insInt == 8 ){
		instrument = "UMSIC_MARIMBA/";
		switch ( input )
		{
		   case 'a':
		      notefile = "marimba_a3_g-3_b3.wav";
		      break;
		   case 's':
		      notefile = "marimba_a4_g-4_b4.wav";
		      break;
		   case 'd':
		      notefile = "marimba_a6_g-6_c7.wav";
		      break;
		   case 'f':
		      notefile = "marimba_b5_a5_c6.wav";
		      break;
		   case 'g':
		      notefile = "marimba_d3_c3_d-3.wav";
		      break;
  	   case 'h':
		      notefile = "marimba_d4_c4_d-4.wav";
		      break;
		   case 'j':
		      notefile = "marimba_d5_c5_d-5.wav";
		      break;
		   default:
		      notefile = "marimba_d6_c-6_d-6.wav";
		      break;
		}
	}

	filepath = path + instrument + notefile;
//	return path + instrument + notefile;
}
